// Java Script Library for Final View BR. Version 1.8 Copyright (c) Jungle Software 2004 - 2007.

const JS_FINAL_VIEW_BR_LIBRARY_LOADED = true;

const JS_FINAL_VIEW_BR_PREFS_FILENAME = "Final View BR Prefs.txt";
const JS_FINAL_VIEW_BR_LOG_FILENAME = "Final View BR Log.txt";

// ====================================== Preferences functuons ======================================

function JS_LoadFinalViewPrefsBR() {

	var JS_prefFile = new File(JS_PREFERENCES_FOLDER + JS_FOLDER_SUFFIX + JS_FINAL_VIEW_BR_PREFS_FILENAME);
	if(JS_prefFile.open("read")) {
		
		var JS_prefData = new Object;

		JS_prefData.separateGraphics = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
		JS_prefData.renderingIntent = JS_GetKeyValueAsIntCS(JS_prefFile.readln());
		JS_prefData.blackPointComp = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
		JS_prefData.diffusionDither = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
			
		JS_prefData.convertToPSD = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
		JS_prefData.saveGraphicsAs = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
			
		JS_prefData.logActions = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
		JS_prefData.clearLog = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
			
		JS_prefFile.close();
		return JS_prefData;
	}
	else {
			
		Window.alert("JS_LoadFinalViewPrefsBR" + JS_CARR_RETURN + "Can't open Preferences File for read operations...");
		return null;
	}
}

function JS_SaveFinalViewPrefsBR(JS_prefData) {

	var JS_prefFile = new File(JS_PREFERENCES_FOLDER + JS_FOLDER_SUFFIX + JS_FINAL_VIEW_BR_PREFS_FILENAME);
	if(JS_prefFile.open("write")) {
		
		JS_prefFile.writeln(JS_SEPARATE_GRAPHICS_KEY + JS_EQUAL_SIGN + JS_prefData.separateGraphics);
		JS_prefFile.writeln(JS_RENDERING_INTENT_KEY + JS_EQUAL_SIGN + JS_prefData.renderingIntent);
		JS_prefFile.writeln(JS_BLACK_POINT_COMPENSATION_KEY + JS_EQUAL_SIGN + JS_prefData.blackPointComp);
		JS_prefFile.writeln(JS_DIFFUSION_DITHER_KEY + JS_EQUAL_SIGN + JS_prefData.diffusionDither);
				
		JS_prefFile.writeln(JS_CONVERT_FORMAT_TO_PSD + JS_EQUAL_SIGN + JS_prefData.convertToPSD);		
		JS_prefFile.writeln(JS_SAVE_GRAPHICS_AS_KEY + JS_EQUAL_SIGN + JS_prefData.saveGraphicsAs);
				
		JS_prefFile.writeln(JS_LOG_ACTIONS_KEY + JS_EQUAL_SIGN + JS_prefData.logActions);		
		JS_prefFile.writeln(JS_CLEAR_LOG_KEY + JS_EQUAL_SIGN + JS_prefData.clearLog);
				
		JS_prefFile.close();
	}
	else Window.alert("JS_SaveFinalViewPrefsBR" + JS_CARR_RETURN + "Can't open Preferences File for write operations...");
}

// ========================================= Gate function ============================================

function JS_FinalViewGateBR(JS_inputTaskFile) {

	app.synchronousMode = true;
	
	app.document.restore();
	app.document.bringToFront();
	
	var JS_prefData = JS_LoadFinalViewPrefsBR();
	
	if(JS_prefData.logActions) {
	
		var JS_logFile = JS_GetLogFileCS(false, JS_FINAL_VIEW_BR_LOG_FILENAME);
		if(JS_logFile) {
		
			JS_logFile.writeln("THIS WILD JUMP WAS SUCCESSFUL. Execution continued in Bridge");
			JS_logFile.writeln("");
		}
		else return;
	}
	else var JS_logFile = null;
		
	if(JS_inputTaskFile.open("read")) {
			
		var JS_selectedMenu = new String(JS_GetKeyValueAsStringCS(JS_inputTaskFile.readln()));
		var JS_inputTaskFileNumber = JS_GetKeyValueAsIntCS(JS_inputTaskFile.readln());
		
		if(JS_inputTaskFileNumber) {
		
			var JS_processedGraphics = new Array;

			for(var JS_indexI = 0; JS_indexI < JS_inputTaskFileNumber; JS_indexI++) {

				var JS_processedObject = new Object;
		
				JS_processedObject.inputFileName = JS_GetKeyValueAsStringCS(JS_inputTaskFile.readln());
				JS_processedObject.outputFileName = JS_GetKeyValueAsStringCS(JS_inputTaskFile.readln());
				JS_processedObject.adjustSharpen = JS_GetKeyValueAsBooleanCS(JS_inputTaskFile.readln());
				JS_processedObject.adjustColor = JS_GetKeyValueAsBooleanCS(JS_inputTaskFile.readln());
				
				JS_processedGraphics.push(JS_processedObject);
			}
					
			JS_inputTaskFile.close();
			JS_inputTaskFile.remove();

			if(app.document.selections.length) {
	
				var JS_allRasterGraphics = new Array;
				JS_allRasterGraphics = JS_GetAllRasterGraphicsBR(app.document.selections, JS_logFile);
				app.document.deselectAll();
			}
			else {
	
				if(app.document.visibleThumbnails.length) {
		
					var JS_allRasterGraphics = new Array;
					JS_allRasterGraphics = JS_GetAllRasterGraphicsBR(app.document.visibleThumbnails, JS_logFile);
				}
				else {
		
					if(JS_logFile) {
			
						var JS_curDate = new Date();
						JS_logFile.writeln("Logging Info: There are no items in the Content pane");
						JS_logFile.writeln("======================= FINISH LOGGING AT: " + JS_curDate + " ========================");
						JS_logFile.close();
						Window.alert("JS_FinalViewGateBR" + JS_CARR_RETURN + "There are no items in the Content pane..." + JS_CARR_RETURN + "See Log File for details...");
					}
					else Window.alert("JS_FinalViewGateBR" + JS_CARR_RETURN + "There are no items in the Content pane...");
					return;
				}
			}
	
			var JS_updatedGraphics = new Array;
			JS_updatedGraphics = JS_GetUpdatedGraphicsBR(JS_allRasterGraphics, JS_selectedMenu);
	
			if(JS_logFile) {
			
				JS_logFile.writeln("	Input File Number = " + JS_processedGraphics.length);
				JS_logFile.writeln("	Ready for Update File Number = " + JS_updatedGraphics.length);
			}
			else ;
				
			if(JS_updatedGraphics.length) {
			
				var JS_updatedNumber = 0;
				for(var JS_indexI = 0; JS_indexI < JS_updatedGraphics.length; JS_indexI++) {
				
					for(var JS_indexJ = 0; JS_indexJ < JS_processedGraphics.length; JS_indexJ++) {
					
						if(JS_updatedGraphics[JS_indexI].spec.absoluteURI == JS_processedGraphics[JS_indexJ].inputFileName) {
							
							if(JS_logFile) JS_logFile.writeln("Updated File: " + decodeURI(JS_updatedGraphics[JS_indexI].spec.absoluteURI));
							else ;
							
							var JS_metaData = JS_updatedGraphics[JS_indexI].synchronousMetadata;
							JS_metaData.namespace = JS_XMP_BASIC_SCHEMA;
							
							if(JS_selectedMenu == JS_FINAL_SHARPEN_MENU_ITEM) {
							
								if(JS_processedGraphics[JS_indexJ].adjustSharpen) {
								
									JS_metaData.Rating = 0;
									JS_updatedNumber++;
							
									if(JS_logFile) JS_logFile.writeln("Update Action: Clear Rating");
									else ;
								}
								else ;
							}
							else {
							
								if(JS_selectedMenu == JS_FINAL_COLOR_MENU_ITEM) {
							
									if(JS_processedGraphics[JS_indexJ].adjustColor) {
									
										JS_metaData.Label = "";
										JS_updatedNumber++;
							
										if(JS_logFile) JS_logFile.writeln("Update Action: Clear Label");
										else ;
									}
									else ;
								}
								else {
							
									if(JS_processedGraphics[JS_indexJ].adjustSharpen) {
									
										JS_metaData.Rating = 0;
										
										if(JS_logFile) JS_logFile.writeln("Update Action: Clear Rating");
										else ;
										
										if(JS_processedGraphics[JS_indexJ].adjustColor) {
										
											JS_metaData.Label = "";
											
											if(JS_logFile) JS_logFile.writeln("Update Action: Clear Label");
											else ;
										}
										else ;
										
										JS_updatedNumber++;
									}
									else {
							
										if(JS_processedGraphics[JS_indexJ].adjustColor) {
										
											JS_metaData.Label = "";
											JS_updatedNumber++;
											
											if(JS_logFile) JS_logFile.writeln("Update Action: Clear Label");
											else ;
										}
										else ;
									}
								}
							}
							
							if(JS_logFile) JS_logFile.writeln("");
							else ;
							
							if(JS_processedGraphics[JS_indexJ].inputFileName != JS_processedGraphics[JS_indexJ].outputFileName) {
							
								var JS_savedAsFile = new File(JS_processedGraphics[JS_indexJ].outputFileName);
								while(!JS_savedAsFile.exists) ;
								
								var JS_savedAsThumbnail = new Thumbnail(JS_savedAsFile);
								JS_metaData = JS_savedAsThumbnail.synchronousMetadata;
								JS_metaData.namespace = JS_XMP_BASIC_SCHEMA;
							
								if(JS_selectedMenu == JS_FINAL_SHARPEN_MENU_ITEM) {
							
									if(JS_processedGraphics[JS_indexJ].adjustSharpen) JS_metaData.Rating = 0;
									else ;
								}
								else {
							
									if(JS_selectedMenu == JS_FINAL_COLOR_MENU_ITEM) {
							
										if(JS_processedGraphics[JS_indexJ].adjustColor) JS_metaData.Label = "";
										else ;
									}
									else {
							
										if(JS_processedGraphics[JS_indexJ].adjustSharpen) {
									
											JS_metaData.Rating = 0;
										
											if(JS_processedGraphics[JS_indexJ].adjustColor) JS_metaData.Label = "";
											else ;
										}
										else {
							
											if(JS_processedGraphics[JS_indexJ].adjustColor) JS_metaData.Label = "";
											else ;
										}
									}
								}
							}
							else ;
						}
						else ;
					}
				}
				
				if(JS_logFile) {
				
					var JS_curDate = new Date();
					JS_logFile.writeln("	Updated Thumbnails Number = " + JS_updatedNumber);
					JS_logFile.writeln("======================= FINISH LOGGING AT: " + JS_curDate + " ========================");
					JS_logFile.close();
					Window.alert("JS_FinalViewGateBR" + JS_CARR_RETURN + "Updated Thumbnails number = " + JS_updatedNumber + JS_CARR_RETURN + "See Log File for details...");
				}
				else Window.alert("JS_FinalViewGateBR" + JS_CARR_RETURN + "Updated Thumbnails number = " + JS_updatedNumber);
			}
			else {
				
				if(JS_logFile) {
				
					var JS_curDate = new Date();
					JS_logFile.writeln("Logging Info: There are no Raster Graphics for update in the Content pane");
					JS_logFile.writeln("======================= FINISH LOGGING AT: " + JS_curDate + " ========================");
					JS_logFile.close();
					Window.alert("JS_FinalViewGateBR" + JS_CARR_RETURN + "There are no Raster Graphics for update in the Content pane..." + JS_CARR_RETURN + "See Log File for details...");
				}
				else Window.alert("JS_FinalViewGateBR" + JS_CARR_RETURN + "There are no Raster Graphics for update in the Content pane...");
			}
		}
		else {
		
			JS_inputTaskFile.close();
			JS_inputTaskFile.remove();

			if(JS_logFile) {
				
				var JS_curDate = new Date();
				JS_logFile.writeln("Logging Info: There are no proscessed files in a Input Task File");
				JS_logFile.writeln("======================= FINISH LOGGING AT: " + JS_curDate + " ========================");
				JS_logFile.close();
				Window.alert("JS_FinalViewGateBR" + JS_CARR_RETURN + "There are no proscessed files in a Input Task File..." + JS_CARR_RETURN + "See Log File for details...");
			}
			else Window.alert("JS_FinalViewGateBR" + JS_CARR_RETURN + "There are no proscessed files in a Input Task File...");
		}
	}
	else {
	
		if(JS_logFile) {
				
			var JS_curDate = new Date();
			JS_logFile.writeln("EXECUTION ERROR: Can't open Input Task File");
			JS_logFile.writeln("======================= FINISH LOGGING AT: " + JS_curDate + " ========================");
			JS_logFile.close();
			Window.alert("JS_FinalViewGateBR" + JS_CARR_RETURN + "EXECUTION ERROR: Can't open Input Task File..." + JS_CARR_RETURN + "See Log File for details...");
		}
		else Window.alert("JS_FinalViewGateBR" + JS_CARR_RETURN + "EXECUTION ERROR: Can't open Input Task File...");
	}
}

// ================================== Menu function ====================================

function JS_FinalViewMenuBR(JS_prefData, JS_finalSharpen, JS_finalColor, JS_selectedMenu) {

	if(JS_prefData.logActions) {
	
		var JS_logFile = JS_GetLogFileCS(JS_prefData.clearLog, JS_FINAL_VIEW_BR_LOG_FILENAME);
		if(JS_logFile) {
		
			var JS_renderingIntents = new Array("Absolute Colorimentric", "Perseptual", "Relative Colorimetric", "Saturation");
			var JS_curDate = new Date();
			JS_logFile.writeln("======================= START LOGGING AT: " + JS_curDate + " ========================");
			JS_logFile.writeln("	Script Paramentrs:");
			JS_logFile.writeln("Final Sharpen=" + JS_finalSharpen);
			JS_logFile.writeln("Final Color=" + JS_finalColor);
			JS_logFile.writeln("	Script Preferences:");
			JS_logFile.writeln("Separate Graphics=" + JS_prefData.separateGraphics);
			if(JS_prefData.separateGraphics) {
			
				JS_logFile.writeln("Rendering Intent=" + JS_renderingIntents[JS_prefData.renderingIntent]);
				JS_logFile.writeln("Black Point Compensation=" + JS_prefData.blackPointComp);
				JS_logFile.writeln("Diffusion Dither=" + JS_prefData.diffusionDither);
			}
			else ;
			JS_logFile.writeln("Convert Format To PSD=" + JS_prefData.convertToPSD);
			JS_logFile.writeln("Save Graphics As=" + JS_prefData.saveGraphicsAs);
			JS_logFile.writeln("Log Actions=" + JS_prefData.logActions);
			JS_logFile.writeln("Clear Log Before Action=" + JS_prefData.clearLog);
			JS_logFile.writeln("");
		}
		else {
		
			Window.alert("Jungle Software" + JS_CARR_RETURN + "Can't open " + JS_FINAL_VIEW_BR_LOG_FILENAME);
			return;
		}
	}
	else var JS_logFile = null;
	
	var JS_allRasterGraphics = new Array;
	if(app.document.selections.length) JS_allRasterGraphics = JS_GetAllRasterGraphicsBR(app.document.selections, JS_logFile);
	else JS_allRasterGraphics = JS_GetAllRasterGraphicsBR(app.document.visibleThumbnails, JS_logFile);

	if(JS_allRasterGraphics.length) {
	
		var JS_finalViewPSData = new Array;
		JS_finalViewPSData = JS_GetFinalViewPSDataBR(JS_allRasterGraphics, JS_finalSharpen, JS_finalColor);
		
		if(JS_finalViewPSData.length) {
		
			app.document.minimize();
			
			var JS_finalViewPSTaskFile = new File(JS_TASK_STATEMENTS_FOLDER + JS_FOLDER_SUFFIX + JS_FINAL_VIEW_PS_TASK_FILENAME);
			if(JS_finalViewPSTaskFile.open("write")) {
		
				JS_finalViewPSTaskFile.writeln(JS_BRIDGE_TARGET_KEY + JS_EQUAL_SIGN + JS_BRIDGE_BRIDGE_TARGET);
				JS_finalViewPSTaskFile.writeln(JS_SCRIPTFILE_KEY + JS_EQUAL_SIGN + JS_FINAL_VIEW_BR_FILENAME);
				JS_finalViewPSTaskFile.writeln(JS_SCRIPTTASK_KEY + JS_EQUAL_SIGN + JS_FINAL_VIEW_BR_TASK_FILENAME);

				JS_finalViewPSTaskFile.writeln(JS_SEPARATE_GRAPHICS_KEY + JS_EQUAL_SIGN + JS_prefData.separateGraphics);
				if(JS_prefData.separateGraphics) {
					
					JS_finalViewPSTaskFile.writeln(JS_RENDERING_INTENT_KEY + JS_EQUAL_SIGN + JS_prefData.renderingIntent);
					JS_finalViewPSTaskFile.writeln(JS_BLACK_POINT_COMPENSATION_KEY + JS_EQUAL_SIGN + JS_prefData.blackPointComp);
					JS_finalViewPSTaskFile.writeln(JS_DIFFUSION_DITHER_KEY + JS_EQUAL_SIGN + JS_prefData.diffusionDither);
				}
				else ;
					
				JS_finalViewPSTaskFile.writeln(JS_CONVERT_FORMAT_TO_PSD + JS_EQUAL_SIGN + JS_prefData.convertToPSD);
				JS_finalViewPSTaskFile.writeln(JS_SAVE_GRAPHICS_AS_KEY + JS_EQUAL_SIGN + JS_prefData.saveGraphicsAs);

				JS_finalViewPSTaskFile.writeln(JS_LOG_ACTIONS_KEY + JS_EQUAL_SIGN + JS_prefData.logActions);
				if(JS_prefData.logActions) JS_finalViewPSTaskFile.writeln(JS_LOG_FILENAME_KEY + JS_EQUAL_SIGN + JS_FINAL_VIEW_BR_LOG_FILENAME);
				else ;

				JS_finalViewPSTaskFile.writeln(JS_FILE_NUMBER_KEY + JS_EQUAL_SIGN + JS_finalViewPSData.length);
		
				if(JS_logFile) JS_logFile.writeln("	Selected Graphics Number = " + JS_finalViewPSData.length);
				else ;
				
				var JS_sharpenModes = new Array("General", "Contour", "Low Detail", "Fine Detail", "Output");
				var JS_colorModes = new Array("Highlights", "Shadows", "Highlights and Shadows", "Highlights and Midtones", "Shadows and Midtones");
				
				for(var JS_indexI = 0; JS_indexI < JS_finalViewPSData.length; JS_indexI++) {
		
					JS_finalViewPSTaskFile.writeln(JS_FULL_FILENAME_KEY + JS_EQUAL_SIGN + JS_finalViewPSData[JS_indexI].fullFileName);
					JS_finalViewPSTaskFile.writeln(JS_SHARPEN_MODE_KEY + JS_EQUAL_SIGN + JS_finalViewPSData[JS_indexI].sharpenMode);
					JS_finalViewPSTaskFile.writeln(JS_COLOR_MODE_KEY + JS_EQUAL_SIGN + JS_finalViewPSData[JS_indexI].colorMode);
					
					if(JS_logFile) {
		
						JS_logFile.writeln(JS_FULL_FILENAME_KEY + JS_EQUAL_SIGN + decodeURI(JS_finalViewPSData[JS_indexI].fullFileName));

						if(JS_finalViewPSData[JS_indexI].sharpenMode == -1)
							JS_logFile.writeln(JS_SHARPEN_MODE_KEY + JS_EQUAL_SIGN + "Disabled");
						else
							JS_logFile.writeln(JS_SHARPEN_MODE_KEY + JS_EQUAL_SIGN + JS_sharpenModes[JS_finalViewPSData[JS_indexI].sharpenMode]);

						if(JS_finalViewPSData[JS_indexI].colorMode == -1)
							JS_logFile.writeln(JS_COLOR_MODE_KEY + JS_EQUAL_SIGN + "Disabled");
						else
							JS_logFile.writeln(JS_COLOR_MODE_KEY + JS_EQUAL_SIGN + JS_colorModes[JS_finalViewPSData[JS_indexI].colorMode]);
							
						JS_logFile.writeln("");
					}
					else ;
				}
				JS_finalViewPSTaskFile.close();
			}
			else {
			
				if(JS_logFile) {
				
					JS_logFile.writeln("EXECUTION ERROR=Final View BR can't create Final View PS Task file");
					JS_logFile.close();
				}
				else Window.alert("JS_FinalViewMenuBR" + JS_CARR_RETURN + "Can't create Final View PS Task file...");
				return;
			}
	
			var JS_finalViewBRTaskFile = new File(JS_TASK_STATEMENTS_FOLDER + JS_FOLDER_SUFFIX + JS_FINAL_VIEW_BR_TASK_FILENAME);
			if(JS_finalViewBRTaskFile.open("write")) {
		
				JS_finalViewBRTaskFile.writeln(JS_SELECTED_MENU_KEY + JS_EQUAL_SIGN + JS_selectedMenu);
				JS_finalViewBRTaskFile.close();
			}
			else {
			
				if(JS_logFile) {
				
					JS_logFile.writeln("EXECUTION ERROR=Final View BR can't create Final View BR Task file");
					JS_logFile.close();
				}
				else Window.alert("JS_FinalViewMenuBR" + JS_CARR_RETURN + "Can't create Final View BR Task file...");
				JS_finalViewPSTaskFile,remove();
				return;
			}
			
			if(JS_logFile) {
				
				JS_logFile.writeln("WILD JUMP OVER A JUNGLE, to " + JS_PHOTOSHOP_BRIDGE_TARGET + " in the depth of " + JS_FINAL_VIEW_PS_FILENAME);
				JS_logFile.close();
			}
			else ;
			
			JS_RunAppScriptCS(JS_PHOTOSHOP_BRIDGE_TARGET, JS_FINAL_VIEW_PS_FILENAME);
		}
		else {
	
			if(JS_logFile) {
				
				JS_logFile.writeln("Logging Info: There are no Raster Graphics for Final View");
				JS_logFile.close();
			}
			else ;
			
			Window.alert("JS_FinalViewMenuBR" + JS_CARR_RETURN + "There are no Raster Graphics for Final View...");
		}
	}
	else {
	
		if(JS_logFile) {
				
			JS_logFile.writeln("Logging Info: There are no Raster Graphics");
			JS_logFile.close();
		}
		else ;
			
		Window.alert("JS_FinalViewMenuBR" + JS_CARR_RETURN + "There are no Raster Graphics...");
	}
}

// =================================== Final View Dialog BR function ===========================

function JS_FinalViewPrefsBR(JS_prefData, JS_selectedMenu) {
	
	var JS_dialogName = new String("");
	JS_dialogName = JS_dialogName.concat(JS_selectedMenu, " Preferences");
	
	var JS_newPrefData = JS_GetRasterPrefsDlgBR(JS_prefData, JS_dialogName);
	if(JS_newPrefData) JS_SaveFinalViewPrefsBR(JS_newPrefData);
	else ;
}
